<?php

namespace Drupal\graphql_address\Plugin\GraphQL\Fields\Address;

use Drupal\graphql\GraphQL\Execution\ResolveContext;
use Drupal\graphql\Plugin\GraphQL\Fields\FieldPluginBase;
use GraphQL\Type\Definition\ResolveInfo;

/**
 * The code for the administrative area.
 *
 * @GraphQLField(
 *   secure = true,
 *   id = "address_administrative_area_code",
 *   name = "code",
 *   parents = {"AddressAdministrativeArea"},
 *   type = "String",
 * )
 */
class AddressAdministrativeAreaCode extends FieldPluginBase {

  /**
   * {@inheritdoc}
   */
  public function resolveValues($value, array $args, ResolveContext $context, ResolveInfo $info) {

    /**
     * @var $administrative_area \CommerceGuys\Addressing\Subdivision\Subdivision
     */
    $administrative_area = $value['value'];

    // Return the name of the administrative area code.
    yield $administrative_area->getCode();
  }

}
