<?php

namespace Drupal\graphql_address\Plugin\GraphQL\Fields\Address;

use Drupal\graphql\GraphQL\Execution\ResolveContext;
use Drupal\graphql\Plugin\GraphQL\Fields\FieldPluginBase;
use GraphQL\Type\Definition\ResolveInfo;

/**
 * A country name for addresses.
 *
 * @GraphQLField(
 *   secure = true,
 *   id = "address_country_name",
 *   name = "name",
 *   parents = {"AddressCountry"},
 *   type = "String",
 * )
 */
class AddressCountryName extends FieldPluginBase {

  /**
   * {@inheritdoc}
   */
  public function resolveValues($value, array $args, ResolveContext $context, ResolveInfo $info) {

    /**
     * @var $country \CommerceGuys\Addressing\Country\Country
     */
    $country = $value['country'];

    yield $country->getName();
  }

}
