<?php

namespace Drupal\graphql_address\Plugin\GraphQL\Fields\Address;

use Drupal\graphql\GraphQL\Execution\ResolveContext;
use Drupal\graphql\Plugin\GraphQL\Fields\FieldPluginBase;
use GraphQL\Type\Definition\ResolveInfo;

/**
 * The name of a dependant locality.
 *
 * @GraphQLField(
 *   secure = true,
 *   id = "address_dependant_locality_code",
 *   name = "code",
 *   parents = {"AddressDependantLocality"},
 *   type = "String",
 * )
 */
class AddressDependantLocalityCode extends FieldPluginBase {

  /**
   * {@inheritdoc}
   */
  public function resolveValues($value, array $args, ResolveContext $context, ResolveInfo $info) {

    /**
     * @var $dependant_locality \CommerceGuys\Addressing\Subdivision\Subdivision
     */
    $dependant_locality = $value['value'];

    // Return the code of the dependant locality area.
    yield $dependant_locality->getCode();
  }

}
