<?php

namespace Drupal\graphql_address\Plugin\GraphQL\Fields\Address;

use Drupal\graphql\GraphQL\Execution\ResolveContext;
use Drupal\graphql\Plugin\GraphQL\Fields\FieldPluginBase;
use GraphQL\Type\Definition\ResolveInfo;

/**
 * The name of a locality
 *
 * @GraphQLField(
 *   secure = true,
 *   id = "address_locality_name",
 *   name = "name",
 *   parents = {"AddressLocality"},
 *   type = "String",
 * )
 */
class AddressLocalityName extends FieldPluginBase {

  /**
   * {@inheritdoc}
   */
  public function resolveValues($value, array $args, ResolveContext $context, ResolveInfo $info) {

    /**
     * @var $locality \CommerceGuys\Addressing\Subdivision\Subdivision
     */
    $locality = $value['value'];

    // Return the name of the locality name.
    yield $locality->getName();
  }

}
